package com.fr.plugin.xxxx.sso;

import com.fr.decision.fun.impl.AbstractLogInOutEventProvider;
import com.fr.decision.webservice.login.LogInOutResultInfo;
import com.fr.general.PropertiesUtils;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.Properties;

/**
 * @Author fr.open
 * @since 2021/7/12
 **/
public class CustomLogInOutEventProvider extends AbstractLogInOutEventProvider {

    private final String apiClientId;

    private final String logoutURL;

    private final String logoutRedirectURL;

    public CustomLogInOutEventProvider() {
        Properties props = PropertiesUtils.getProperties("xxxx");
        this.apiClientId = CommonUtils.getProperty(props, "api.client-id", false);
        this.logoutURL = CommonUtils.getProperty(props, "api.logout", false);
        this.logoutRedirectURL = CommonUtils.getProperty(props, "api.logout-redirct-url", "http://www.baidu.com", true);
    }

    @Override
    public String logoutAction(LogInOutResultInfo result) {
        try {
            return String.format("%s?redirctToUrl=%s&redirectToLogin=true&entityId=%s",
                    logoutURL,
                    URLEncoder.encode(logoutRedirectURL, "utf-8"),
                    apiClientId);
        } catch (UnsupportedEncodingException e) {
            throw new RuntimeException(e);
        }
    }
}
